/**
 * @defgroup timers Timers
 * @author Jacek Łysiak <jl345639@students.mimuw.edu.pl>
 * Software timers manager
 * Timers manager based on TIM1 hardware timer.
 * Tick generated by UP event Interrupt.
 */

/**
 * @file
 * @ingroup timers
 */

#ifndef TIMER_H
#define TIMER_H

#include <stdint.h>

/**
 * Timer event handler structure
 */
typedef struct tim_t tim_t;

/**
 * Initialize timers.
 * @param fclk CPU clock
 * @param base Timer base frequency
 */
void timer_init(uint32_t fclk, uint32_t base);

/**
 * Start timer.
 * Call 'h' timer handler 'reps' times every 'period' ms.
 * @param[in] h Timer handler f( #tick )
 * @param period Period in ms
 * @param reps Repetitions ( 0 reps = infinity )
 * @return timer
 */
tim_t *timer_start(void (*h)(uint16_t), uint16_t period, uint16_t reps);

/**
 * Remove handler.
 * @param[in] t timer
 */
void timer_remove(tim_t *t);

/**
 * Check elapsed time of timer.
 * @param[in] t timer
 * @return timer total time in @ref TIMER_BASE_FREQ units
 */
uint32_t timer_check(tim_t *t);

#endif //TIMER_H
